import * as _typescript_eslint_utils_ts_eslint from '@typescript-eslint/utils/ts-eslint';
import * as _eslint_react_shared from '@eslint-react/shared';
import tsParser from '@typescript-eslint/parser';
import * as reactCore from 'eslint-plugin-react-core';
import * as reactDom from 'eslint-plugin-react-dom';
import * as reactHooksExtra from 'eslint-plugin-react-hooks-extra';
import * as reactNamingConvention from 'eslint-plugin-react-naming-convention';

declare const _default: {
    readonly meta: {
        readonly name: string;
        readonly version: string;
    };
    readonly configs: {
        readonly all: {
            readonly languageOptions: {
                readonly parser: typeof tsParser;
            };
            readonly plugins: {
                readonly "@eslint-react": typeof reactCore;
                readonly "@eslint-react/dom": typeof reactDom;
                readonly "@eslint-react/hooks-extra": typeof reactHooksExtra;
                readonly "@eslint-react/naming-convention": typeof reactNamingConvention;
            };
            readonly rules: {
                readonly "@eslint-react/avoid-shorthand-boolean": "warn";
                readonly "@eslint-react/avoid-shorthand-fragment": "warn";
                readonly "@eslint-react/ensure-forward-ref-using-ref": "warn";
                readonly "@eslint-react/no-access-state-in-setstate": "error";
                readonly "@eslint-react/no-array-index-key": "warn";
                readonly "@eslint-react/no-children-count": "warn";
                readonly "@eslint-react/no-children-for-each": "warn";
                readonly "@eslint-react/no-children-map": "warn";
                readonly "@eslint-react/no-children-only": "warn";
                readonly "@eslint-react/no-children-prop": "warn";
                readonly "@eslint-react/no-children-to-array": "warn";
                readonly "@eslint-react/no-class-component": "warn";
                readonly "@eslint-react/no-clone-element": "warn";
                readonly "@eslint-react/no-comment-textnodes": "warn";
                readonly "@eslint-react/no-component-will-mount": "error";
                readonly "@eslint-react/no-component-will-receive-props": "error";
                readonly "@eslint-react/no-component-will-update": "error";
                readonly "@eslint-react/no-create-ref": "error";
                readonly "@eslint-react/no-direct-mutation-state": "error";
                readonly "@eslint-react/no-duplicate-key": "error";
                readonly "@eslint-react/no-missing-component-display-name": "warn";
                readonly "@eslint-react/no-missing-key": "error";
                readonly "@eslint-react/no-nested-components": "warn";
                readonly "@eslint-react/no-redundant-should-component-update": "error";
                readonly "@eslint-react/no-set-state-in-component-did-mount": "warn";
                readonly "@eslint-react/no-set-state-in-component-did-update": "warn";
                readonly "@eslint-react/no-set-state-in-component-will-update": "warn";
                readonly "@eslint-react/no-string-refs": "error";
                readonly "@eslint-react/no-unsafe-component-will-mount": "warn";
                readonly "@eslint-react/no-unsafe-component-will-receive-props": "warn";
                readonly "@eslint-react/no-unsafe-component-will-update": "warn";
                readonly "@eslint-react/no-unstable-context-value": "error";
                readonly "@eslint-react/no-unstable-default-props": "error";
                readonly "@eslint-react/no-unused-class-component-members": "warn";
                readonly "@eslint-react/no-unused-state": "warn";
                readonly "@eslint-react/no-useless-fragment": "warn";
                readonly "@eslint-react/prefer-destructuring-assignment": "warn";
                readonly "@eslint-react/prefer-shorthand-boolean": "warn";
                readonly "@eslint-react/prefer-shorthand-fragment": "warn";
                readonly "@eslint-react/dom/no-children-in-void-dom-elements": "warn";
                readonly "@eslint-react/dom/no-dangerously-set-innerhtml": "warn";
                readonly "@eslint-react/dom/no-dangerously-set-innerhtml-with-children": "error";
                readonly "@eslint-react/dom/no-find-dom-node": "error";
                readonly "@eslint-react/dom/no-missing-button-type": "warn";
                readonly "@eslint-react/dom/no-missing-iframe-sandbox": "warn";
                readonly "@eslint-react/dom/no-namespace": "error";
                readonly "@eslint-react/dom/no-render-return-value": "error";
                readonly "@eslint-react/dom/no-script-url": "warn";
                readonly "@eslint-react/dom/no-unsafe-iframe-sandbox": "warn";
                readonly "@eslint-react/dom/no-unsafe-target-blank": "warn";
                readonly "@eslint-react/hooks-extra/ensure-custom-hooks-using-other-hooks": "warn";
                readonly "@eslint-react/hooks-extra/ensure-use-callback-has-non-empty-deps": "warn";
                readonly "@eslint-react/hooks-extra/ensure-use-memo-has-non-empty-deps": "warn";
                readonly "@eslint-react/hooks-extra/prefer-use-state-lazy-initialization": "warn";
                readonly "@eslint-react/naming-convention/component-name": "warn";
                readonly "@eslint-react/naming-convention/filename": "warn";
                readonly "@eslint-react/naming-convention/filename-extension": "warn";
                readonly "@eslint-react/naming-convention/use-state": "warn";
            };
        };
        readonly debug: {
            readonly languageOptions: {
                readonly parser: typeof tsParser;
            };
            readonly plugins: {
                readonly "@eslint-react": typeof reactCore;
                readonly "@eslint-react/dom": typeof reactDom;
                readonly "@eslint-react/hooks-extra": typeof reactHooksExtra;
                readonly "@eslint-react/naming-convention": typeof reactNamingConvention;
            };
            readonly rules: {
                readonly "@eslint-react/debug/class-component": "warn";
                readonly "@eslint-react/debug/function-component": "warn";
                readonly "@eslint-react/debug/react-hooks": "warn";
            };
        };
        readonly dom: {
            readonly languageOptions: {
                readonly parser: typeof tsParser;
            };
            readonly plugins: {
                readonly "@eslint-react": typeof reactCore;
                readonly "@eslint-react/dom": typeof reactDom;
                readonly "@eslint-react/hooks-extra": typeof reactHooksExtra;
                readonly "@eslint-react/naming-convention": typeof reactNamingConvention;
            };
            readonly rules: {
                readonly "@eslint-react/dom/no-children-in-void-dom-elements": "warn";
                readonly "@eslint-react/dom/no-dangerously-set-innerhtml": "warn";
                readonly "@eslint-react/dom/no-dangerously-set-innerhtml-with-children": "error";
                readonly "@eslint-react/dom/no-find-dom-node": "error";
                readonly "@eslint-react/dom/no-missing-button-type": "warn";
                readonly "@eslint-react/dom/no-missing-iframe-sandbox": "warn";
                readonly "@eslint-react/dom/no-namespace": "error";
                readonly "@eslint-react/dom/no-script-url": "warn";
                readonly "@eslint-react/dom/no-unsafe-iframe-sandbox": "warn";
                readonly "@eslint-react/dom/no-unsafe-target-blank": "warn";
            };
        };
        readonly off: {
            readonly languageOptions: {
                readonly parser: typeof tsParser;
            };
            readonly plugins: {
                readonly "@eslint-react": typeof reactCore;
                readonly "@eslint-react/dom": typeof reactDom;
                readonly "@eslint-react/hooks-extra": typeof reactHooksExtra;
                readonly "@eslint-react/naming-convention": typeof reactNamingConvention;
            };
            readonly rules: {
                "@eslint-react/avoid-shorthand-boolean": never;
                "@eslint-react/avoid-shorthand-fragment": never;
                "@eslint-react/ensure-forward-ref-using-ref": never;
                "@eslint-react/no-access-state-in-setstate": never;
                "@eslint-react/no-array-index-key": never;
                "@eslint-react/no-children-count": never;
                "@eslint-react/no-children-for-each": never;
                "@eslint-react/no-children-map": never;
                "@eslint-react/no-children-only": never;
                "@eslint-react/no-children-prop": never;
                "@eslint-react/no-children-to-array": never;
                "@eslint-react/no-class-component": never;
                "@eslint-react/no-clone-element": never;
                "@eslint-react/no-comment-textnodes": never;
                "@eslint-react/no-component-will-mount": never;
                "@eslint-react/no-component-will-receive-props": never;
                "@eslint-react/no-component-will-update": never;
                "@eslint-react/no-create-ref": never;
                "@eslint-react/no-direct-mutation-state": never;
                "@eslint-react/no-duplicate-key": never;
                "@eslint-react/no-missing-component-display-name": never;
                "@eslint-react/no-missing-key": never;
                "@eslint-react/no-nested-components": never;
                "@eslint-react/no-redundant-should-component-update": never;
                "@eslint-react/no-set-state-in-component-did-mount": never;
                "@eslint-react/no-set-state-in-component-did-update": never;
                "@eslint-react/no-set-state-in-component-will-update": never;
                "@eslint-react/no-string-refs": never;
                "@eslint-react/no-unsafe-component-will-mount": never;
                "@eslint-react/no-unsafe-component-will-receive-props": never;
                "@eslint-react/no-unsafe-component-will-update": never;
                "@eslint-react/no-unstable-context-value": never;
                "@eslint-react/no-unstable-default-props": never;
                "@eslint-react/no-unused-class-component-members": never;
                "@eslint-react/no-unused-state": never;
                "@eslint-react/no-useless-fragment": never;
                "@eslint-react/prefer-destructuring-assignment": never;
                "@eslint-react/prefer-shorthand-boolean": never;
                "@eslint-react/prefer-shorthand-fragment": never;
                "@eslint-react/dom/no-children-in-void-dom-elements": never;
                "@eslint-react/dom/no-dangerously-set-innerhtml": never;
                "@eslint-react/dom/no-dangerously-set-innerhtml-with-children": never;
                "@eslint-react/dom/no-find-dom-node": never;
                "@eslint-react/dom/no-missing-button-type": never;
                "@eslint-react/dom/no-missing-iframe-sandbox": never;
                "@eslint-react/dom/no-namespace": never;
                "@eslint-react/dom/no-render-return-value": never;
                "@eslint-react/dom/no-script-url": never;
                "@eslint-react/dom/no-unsafe-iframe-sandbox": never;
                "@eslint-react/dom/no-unsafe-target-blank": never;
                "@eslint-react/hooks-extra/ensure-custom-hooks-using-other-hooks": never;
                "@eslint-react/hooks-extra/ensure-use-callback-has-non-empty-deps": never;
                "@eslint-react/hooks-extra/ensure-use-memo-has-non-empty-deps": never;
                "@eslint-react/hooks-extra/prefer-use-state-lazy-initialization": never;
                "@eslint-react/naming-convention/component-name": never;
                "@eslint-react/naming-convention/filename": never;
                "@eslint-react/naming-convention/filename-extension": never;
                "@eslint-react/naming-convention/use-state": never;
            };
        };
        readonly "off-dom": {
            readonly languageOptions: {
                readonly parser: typeof tsParser;
            };
            readonly plugins: {
                readonly "@eslint-react": typeof reactCore;
                readonly "@eslint-react/dom": typeof reactDom;
                readonly "@eslint-react/hooks-extra": typeof reactHooksExtra;
                readonly "@eslint-react/naming-convention": typeof reactNamingConvention;
            };
            readonly rules: {
                "@eslint-react/dom/no-children-in-void-dom-elements": never;
                "@eslint-react/dom/no-dangerously-set-innerhtml": never;
                "@eslint-react/dom/no-dangerously-set-innerhtml-with-children": never;
                "@eslint-react/dom/no-find-dom-node": never;
                "@eslint-react/dom/no-missing-button-type": never;
                "@eslint-react/dom/no-missing-iframe-sandbox": never;
                "@eslint-react/dom/no-namespace": never;
                "@eslint-react/dom/no-script-url": never;
                "@eslint-react/dom/no-unsafe-iframe-sandbox": never;
                "@eslint-react/dom/no-unsafe-target-blank": never;
            };
        };
        readonly recommended: {
            readonly languageOptions: {
                readonly parser: typeof tsParser;
            };
            readonly plugins: {
                readonly "@eslint-react": typeof reactCore;
                readonly "@eslint-react/dom": typeof reactDom;
                readonly "@eslint-react/hooks-extra": typeof reactHooksExtra;
                readonly "@eslint-react/naming-convention": typeof reactNamingConvention;
            };
            readonly rules: {
                readonly "@eslint-react/ensure-forward-ref-using-ref": "warn";
                readonly "@eslint-react/no-access-state-in-setstate": "error";
                readonly "@eslint-react/no-array-index-key": "warn";
                readonly "@eslint-react/no-children-count": "warn";
                readonly "@eslint-react/no-children-for-each": "warn";
                readonly "@eslint-react/no-children-map": "warn";
                readonly "@eslint-react/no-children-only": "warn";
                readonly "@eslint-react/no-children-prop": "warn";
                readonly "@eslint-react/no-children-to-array": "warn";
                readonly "@eslint-react/no-clone-element": "warn";
                readonly "@eslint-react/no-comment-textnodes": "warn";
                readonly "@eslint-react/no-component-will-mount": "error";
                readonly "@eslint-react/no-component-will-receive-props": "error";
                readonly "@eslint-react/no-component-will-update": "error";
                readonly "@eslint-react/no-create-ref": "error";
                readonly "@eslint-react/no-direct-mutation-state": "error";
                readonly "@eslint-react/no-duplicate-key": "error";
                readonly "@eslint-react/no-missing-key": "error";
                readonly "@eslint-react/no-nested-components": "warn";
                readonly "@eslint-react/no-redundant-should-component-update": "error";
                readonly "@eslint-react/no-set-state-in-component-did-mount": "warn";
                readonly "@eslint-react/no-set-state-in-component-did-update": "warn";
                readonly "@eslint-react/no-set-state-in-component-will-update": "warn";
                readonly "@eslint-react/no-string-refs": "error";
                readonly "@eslint-react/no-unsafe-component-will-mount": "warn";
                readonly "@eslint-react/no-unsafe-component-will-receive-props": "warn";
                readonly "@eslint-react/no-unsafe-component-will-update": "warn";
                readonly "@eslint-react/no-unstable-context-value": "error";
                readonly "@eslint-react/no-unstable-default-props": "error";
                readonly "@eslint-react/no-unused-class-component-members": "warn";
                readonly "@eslint-react/no-unused-state": "warn";
                readonly "@eslint-react/no-useless-fragment": "warn";
                readonly "@eslint-react/prefer-destructuring-assignment": "warn";
                readonly "@eslint-react/prefer-shorthand-boolean": "warn";
                readonly "@eslint-react/prefer-shorthand-fragment": "warn";
                readonly "@eslint-react/dom/no-children-in-void-dom-elements": "warn";
                readonly "@eslint-react/dom/no-dangerously-set-innerhtml": "warn";
                readonly "@eslint-react/dom/no-dangerously-set-innerhtml-with-children": "error";
                readonly "@eslint-react/dom/no-find-dom-node": "error";
                readonly "@eslint-react/dom/no-missing-button-type": "warn";
                readonly "@eslint-react/dom/no-missing-iframe-sandbox": "warn";
                readonly "@eslint-react/dom/no-namespace": "error";
                readonly "@eslint-react/dom/no-render-return-value": "error";
                readonly "@eslint-react/dom/no-script-url": "warn";
                readonly "@eslint-react/dom/no-unsafe-iframe-sandbox": "warn";
                readonly "@eslint-react/dom/no-unsafe-target-blank": "warn";
            };
        };
        readonly "recommended-type-checked": {
            readonly languageOptions: {
                readonly parser: typeof tsParser;
            };
            readonly plugins: {
                readonly "@eslint-react": typeof reactCore;
                readonly "@eslint-react/dom": typeof reactDom;
                readonly "@eslint-react/hooks-extra": typeof reactHooksExtra;
                readonly "@eslint-react/naming-convention": typeof reactNamingConvention;
            };
            readonly rules: {
                readonly "@eslint-react/no-leaked-conditional-rendering": "warn";
                readonly "@eslint-react/ensure-forward-ref-using-ref": "warn";
                readonly "@eslint-react/no-access-state-in-setstate": "error";
                readonly "@eslint-react/no-array-index-key": "warn";
                readonly "@eslint-react/no-children-count": "warn";
                readonly "@eslint-react/no-children-for-each": "warn";
                readonly "@eslint-react/no-children-map": "warn";
                readonly "@eslint-react/no-children-only": "warn";
                readonly "@eslint-react/no-children-prop": "warn";
                readonly "@eslint-react/no-children-to-array": "warn";
                readonly "@eslint-react/no-clone-element": "warn";
                readonly "@eslint-react/no-comment-textnodes": "warn";
                readonly "@eslint-react/no-component-will-mount": "error";
                readonly "@eslint-react/no-component-will-receive-props": "error";
                readonly "@eslint-react/no-component-will-update": "error";
                readonly "@eslint-react/no-create-ref": "error";
                readonly "@eslint-react/no-direct-mutation-state": "error";
                readonly "@eslint-react/no-duplicate-key": "error";
                readonly "@eslint-react/no-missing-key": "error";
                readonly "@eslint-react/no-nested-components": "warn";
                readonly "@eslint-react/no-redundant-should-component-update": "error";
                readonly "@eslint-react/no-set-state-in-component-did-mount": "warn";
                readonly "@eslint-react/no-set-state-in-component-did-update": "warn";
                readonly "@eslint-react/no-set-state-in-component-will-update": "warn";
                readonly "@eslint-react/no-string-refs": "error";
                readonly "@eslint-react/no-unsafe-component-will-mount": "warn";
                readonly "@eslint-react/no-unsafe-component-will-receive-props": "warn";
                readonly "@eslint-react/no-unsafe-component-will-update": "warn";
                readonly "@eslint-react/no-unstable-context-value": "error";
                readonly "@eslint-react/no-unstable-default-props": "error";
                readonly "@eslint-react/no-unused-class-component-members": "warn";
                readonly "@eslint-react/no-unused-state": "warn";
                readonly "@eslint-react/no-useless-fragment": "warn";
                readonly "@eslint-react/prefer-destructuring-assignment": "warn";
                readonly "@eslint-react/prefer-shorthand-boolean": "warn";
                readonly "@eslint-react/prefer-shorthand-fragment": "warn";
                readonly "@eslint-react/dom/no-children-in-void-dom-elements": "warn";
                readonly "@eslint-react/dom/no-dangerously-set-innerhtml": "warn";
                readonly "@eslint-react/dom/no-dangerously-set-innerhtml-with-children": "error";
                readonly "@eslint-react/dom/no-find-dom-node": "error";
                readonly "@eslint-react/dom/no-missing-button-type": "warn";
                readonly "@eslint-react/dom/no-missing-iframe-sandbox": "warn";
                readonly "@eslint-react/dom/no-namespace": "error";
                readonly "@eslint-react/dom/no-render-return-value": "error";
                readonly "@eslint-react/dom/no-script-url": "warn";
                readonly "@eslint-react/dom/no-unsafe-iframe-sandbox": "warn";
                readonly "@eslint-react/dom/no-unsafe-target-blank": "warn";
            };
        };
        readonly "all-legacy": {
            readonly parser: "@typescript-eslint/parser";
            readonly plugins: readonly ["@eslint-react"];
            readonly rules: {
                readonly "@eslint-react/avoid-shorthand-boolean": "warn";
                readonly "@eslint-react/avoid-shorthand-fragment": "warn";
                readonly "@eslint-react/ensure-forward-ref-using-ref": "warn";
                readonly "@eslint-react/no-access-state-in-setstate": "error";
                readonly "@eslint-react/no-array-index-key": "warn";
                readonly "@eslint-react/no-children-count": "warn";
                readonly "@eslint-react/no-children-for-each": "warn";
                readonly "@eslint-react/no-children-map": "warn";
                readonly "@eslint-react/no-children-only": "warn";
                readonly "@eslint-react/no-children-prop": "warn";
                readonly "@eslint-react/no-children-to-array": "warn";
                readonly "@eslint-react/no-class-component": "warn";
                readonly "@eslint-react/no-clone-element": "warn";
                readonly "@eslint-react/no-comment-textnodes": "warn";
                readonly "@eslint-react/no-component-will-mount": "error";
                readonly "@eslint-react/no-component-will-receive-props": "error";
                readonly "@eslint-react/no-component-will-update": "error";
                readonly "@eslint-react/no-create-ref": "error";
                readonly "@eslint-react/no-direct-mutation-state": "error";
                readonly "@eslint-react/no-duplicate-key": "error";
                readonly "@eslint-react/no-missing-component-display-name": "warn";
                readonly "@eslint-react/no-missing-key": "error";
                readonly "@eslint-react/no-nested-components": "warn";
                readonly "@eslint-react/no-redundant-should-component-update": "error";
                readonly "@eslint-react/no-set-state-in-component-did-mount": "warn";
                readonly "@eslint-react/no-set-state-in-component-did-update": "warn";
                readonly "@eslint-react/no-set-state-in-component-will-update": "warn";
                readonly "@eslint-react/no-string-refs": "error";
                readonly "@eslint-react/no-unsafe-component-will-mount": "warn";
                readonly "@eslint-react/no-unsafe-component-will-receive-props": "warn";
                readonly "@eslint-react/no-unsafe-component-will-update": "warn";
                readonly "@eslint-react/no-unstable-context-value": "error";
                readonly "@eslint-react/no-unstable-default-props": "error";
                readonly "@eslint-react/no-unused-class-component-members": "warn";
                readonly "@eslint-react/no-unused-state": "warn";
                readonly "@eslint-react/no-useless-fragment": "warn";
                readonly "@eslint-react/prefer-destructuring-assignment": "warn";
                readonly "@eslint-react/prefer-shorthand-boolean": "warn";
                readonly "@eslint-react/prefer-shorthand-fragment": "warn";
                readonly "@eslint-react/dom/no-children-in-void-dom-elements": "warn";
                readonly "@eslint-react/dom/no-dangerously-set-innerhtml": "warn";
                readonly "@eslint-react/dom/no-dangerously-set-innerhtml-with-children": "error";
                readonly "@eslint-react/dom/no-find-dom-node": "error";
                readonly "@eslint-react/dom/no-missing-button-type": "warn";
                readonly "@eslint-react/dom/no-missing-iframe-sandbox": "warn";
                readonly "@eslint-react/dom/no-namespace": "error";
                readonly "@eslint-react/dom/no-render-return-value": "error";
                readonly "@eslint-react/dom/no-script-url": "warn";
                readonly "@eslint-react/dom/no-unsafe-iframe-sandbox": "warn";
                readonly "@eslint-react/dom/no-unsafe-target-blank": "warn";
                readonly "@eslint-react/hooks-extra/ensure-custom-hooks-using-other-hooks": "warn";
                readonly "@eslint-react/hooks-extra/ensure-use-callback-has-non-empty-deps": "warn";
                readonly "@eslint-react/hooks-extra/ensure-use-memo-has-non-empty-deps": "warn";
                readonly "@eslint-react/hooks-extra/prefer-use-state-lazy-initialization": "warn";
                readonly "@eslint-react/naming-convention/component-name": "warn";
                readonly "@eslint-react/naming-convention/filename": "warn";
                readonly "@eslint-react/naming-convention/filename-extension": "warn";
                readonly "@eslint-react/naming-convention/use-state": "warn";
            };
        };
        readonly "debug-legacy": {
            readonly parser: "@typescript-eslint/parser";
            readonly plugins: readonly ["@eslint-react"];
            readonly rules: {
                readonly "@eslint-react/debug/class-component": "warn";
                readonly "@eslint-react/debug/function-component": "warn";
                readonly "@eslint-react/debug/react-hooks": "warn";
            };
        };
        readonly "dom-legacy": {
            readonly parser: "@typescript-eslint/parser";
            readonly plugins: readonly ["@eslint-react"];
            readonly rules: {
                readonly "@eslint-react/dom/no-children-in-void-dom-elements": "warn";
                readonly "@eslint-react/dom/no-dangerously-set-innerhtml": "warn";
                readonly "@eslint-react/dom/no-dangerously-set-innerhtml-with-children": "error";
                readonly "@eslint-react/dom/no-find-dom-node": "error";
                readonly "@eslint-react/dom/no-missing-button-type": "warn";
                readonly "@eslint-react/dom/no-missing-iframe-sandbox": "warn";
                readonly "@eslint-react/dom/no-namespace": "error";
                readonly "@eslint-react/dom/no-script-url": "warn";
                readonly "@eslint-react/dom/no-unsafe-iframe-sandbox": "warn";
                readonly "@eslint-react/dom/no-unsafe-target-blank": "warn";
            };
        };
        readonly "off-dom-legacy": {
            readonly parser: "@typescript-eslint/parser";
            readonly plugins: readonly ["@eslint-react"];
            readonly rules: {
                "@eslint-react/dom/no-children-in-void-dom-elements": never;
                "@eslint-react/dom/no-dangerously-set-innerhtml": never;
                "@eslint-react/dom/no-dangerously-set-innerhtml-with-children": never;
                "@eslint-react/dom/no-find-dom-node": never;
                "@eslint-react/dom/no-missing-button-type": never;
                "@eslint-react/dom/no-missing-iframe-sandbox": never;
                "@eslint-react/dom/no-namespace": never;
                "@eslint-react/dom/no-script-url": never;
                "@eslint-react/dom/no-unsafe-iframe-sandbox": never;
                "@eslint-react/dom/no-unsafe-target-blank": never;
            };
        };
        readonly "off-legacy": {
            readonly parser: "@typescript-eslint/parser";
            readonly plugins: readonly ["@eslint-react"];
            readonly rules: {
                "@eslint-react/avoid-shorthand-boolean": never;
                "@eslint-react/avoid-shorthand-fragment": never;
                "@eslint-react/ensure-forward-ref-using-ref": never;
                "@eslint-react/no-access-state-in-setstate": never;
                "@eslint-react/no-array-index-key": never;
                "@eslint-react/no-children-count": never;
                "@eslint-react/no-children-for-each": never;
                "@eslint-react/no-children-map": never;
                "@eslint-react/no-children-only": never;
                "@eslint-react/no-children-prop": never;
                "@eslint-react/no-children-to-array": never;
                "@eslint-react/no-class-component": never;
                "@eslint-react/no-clone-element": never;
                "@eslint-react/no-comment-textnodes": never;
                "@eslint-react/no-component-will-mount": never;
                "@eslint-react/no-component-will-receive-props": never;
                "@eslint-react/no-component-will-update": never;
                "@eslint-react/no-create-ref": never;
                "@eslint-react/no-direct-mutation-state": never;
                "@eslint-react/no-duplicate-key": never;
                "@eslint-react/no-missing-component-display-name": never;
                "@eslint-react/no-missing-key": never;
                "@eslint-react/no-nested-components": never;
                "@eslint-react/no-redundant-should-component-update": never;
                "@eslint-react/no-set-state-in-component-did-mount": never;
                "@eslint-react/no-set-state-in-component-did-update": never;
                "@eslint-react/no-set-state-in-component-will-update": never;
                "@eslint-react/no-string-refs": never;
                "@eslint-react/no-unsafe-component-will-mount": never;
                "@eslint-react/no-unsafe-component-will-receive-props": never;
                "@eslint-react/no-unsafe-component-will-update": never;
                "@eslint-react/no-unstable-context-value": never;
                "@eslint-react/no-unstable-default-props": never;
                "@eslint-react/no-unused-class-component-members": never;
                "@eslint-react/no-unused-state": never;
                "@eslint-react/no-useless-fragment": never;
                "@eslint-react/prefer-destructuring-assignment": never;
                "@eslint-react/prefer-shorthand-boolean": never;
                "@eslint-react/prefer-shorthand-fragment": never;
                "@eslint-react/dom/no-children-in-void-dom-elements": never;
                "@eslint-react/dom/no-dangerously-set-innerhtml": never;
                "@eslint-react/dom/no-dangerously-set-innerhtml-with-children": never;
                "@eslint-react/dom/no-find-dom-node": never;
                "@eslint-react/dom/no-missing-button-type": never;
                "@eslint-react/dom/no-missing-iframe-sandbox": never;
                "@eslint-react/dom/no-namespace": never;
                "@eslint-react/dom/no-render-return-value": never;
                "@eslint-react/dom/no-script-url": never;
                "@eslint-react/dom/no-unsafe-iframe-sandbox": never;
                "@eslint-react/dom/no-unsafe-target-blank": never;
                "@eslint-react/hooks-extra/ensure-custom-hooks-using-other-hooks": never;
                "@eslint-react/hooks-extra/ensure-use-callback-has-non-empty-deps": never;
                "@eslint-react/hooks-extra/ensure-use-memo-has-non-empty-deps": never;
                "@eslint-react/hooks-extra/prefer-use-state-lazy-initialization": never;
                "@eslint-react/naming-convention/component-name": never;
                "@eslint-react/naming-convention/filename": never;
                "@eslint-react/naming-convention/filename-extension": never;
                "@eslint-react/naming-convention/use-state": never;
            };
        };
        readonly "recommended-legacy": {
            readonly parser: "@typescript-eslint/parser";
            readonly plugins: readonly ["@eslint-react"];
            readonly rules: {
                readonly "@eslint-react/ensure-forward-ref-using-ref": "warn";
                readonly "@eslint-react/no-access-state-in-setstate": "error";
                readonly "@eslint-react/no-array-index-key": "warn";
                readonly "@eslint-react/no-children-count": "warn";
                readonly "@eslint-react/no-children-for-each": "warn";
                readonly "@eslint-react/no-children-map": "warn";
                readonly "@eslint-react/no-children-only": "warn";
                readonly "@eslint-react/no-children-prop": "warn";
                readonly "@eslint-react/no-children-to-array": "warn";
                readonly "@eslint-react/no-clone-element": "warn";
                readonly "@eslint-react/no-comment-textnodes": "warn";
                readonly "@eslint-react/no-component-will-mount": "error";
                readonly "@eslint-react/no-component-will-receive-props": "error";
                readonly "@eslint-react/no-component-will-update": "error";
                readonly "@eslint-react/no-create-ref": "error";
                readonly "@eslint-react/no-direct-mutation-state": "error";
                readonly "@eslint-react/no-duplicate-key": "error";
                readonly "@eslint-react/no-missing-key": "error";
                readonly "@eslint-react/no-nested-components": "warn";
                readonly "@eslint-react/no-redundant-should-component-update": "error";
                readonly "@eslint-react/no-set-state-in-component-did-mount": "warn";
                readonly "@eslint-react/no-set-state-in-component-did-update": "warn";
                readonly "@eslint-react/no-set-state-in-component-will-update": "warn";
                readonly "@eslint-react/no-string-refs": "error";
                readonly "@eslint-react/no-unsafe-component-will-mount": "warn";
                readonly "@eslint-react/no-unsafe-component-will-receive-props": "warn";
                readonly "@eslint-react/no-unsafe-component-will-update": "warn";
                readonly "@eslint-react/no-unstable-context-value": "error";
                readonly "@eslint-react/no-unstable-default-props": "error";
                readonly "@eslint-react/no-unused-class-component-members": "warn";
                readonly "@eslint-react/no-unused-state": "warn";
                readonly "@eslint-react/no-useless-fragment": "warn";
                readonly "@eslint-react/prefer-destructuring-assignment": "warn";
                readonly "@eslint-react/prefer-shorthand-boolean": "warn";
                readonly "@eslint-react/prefer-shorthand-fragment": "warn";
                readonly "@eslint-react/dom/no-children-in-void-dom-elements": "warn";
                readonly "@eslint-react/dom/no-dangerously-set-innerhtml": "warn";
                readonly "@eslint-react/dom/no-dangerously-set-innerhtml-with-children": "error";
                readonly "@eslint-react/dom/no-find-dom-node": "error";
                readonly "@eslint-react/dom/no-missing-button-type": "warn";
                readonly "@eslint-react/dom/no-missing-iframe-sandbox": "warn";
                readonly "@eslint-react/dom/no-namespace": "error";
                readonly "@eslint-react/dom/no-render-return-value": "error";
                readonly "@eslint-react/dom/no-script-url": "warn";
                readonly "@eslint-react/dom/no-unsafe-iframe-sandbox": "warn";
                readonly "@eslint-react/dom/no-unsafe-target-blank": "warn";
            };
        };
        readonly "recommended-type-checked-legacy": {
            readonly parser: "@typescript-eslint/parser";
            readonly plugins: readonly ["@eslint-react"];
            readonly rules: {
                readonly "@eslint-react/no-leaked-conditional-rendering": "warn";
                readonly "@eslint-react/ensure-forward-ref-using-ref": "warn";
                readonly "@eslint-react/no-access-state-in-setstate": "error";
                readonly "@eslint-react/no-array-index-key": "warn";
                readonly "@eslint-react/no-children-count": "warn";
                readonly "@eslint-react/no-children-for-each": "warn";
                readonly "@eslint-react/no-children-map": "warn";
                readonly "@eslint-react/no-children-only": "warn";
                readonly "@eslint-react/no-children-prop": "warn";
                readonly "@eslint-react/no-children-to-array": "warn";
                readonly "@eslint-react/no-clone-element": "warn";
                readonly "@eslint-react/no-comment-textnodes": "warn";
                readonly "@eslint-react/no-component-will-mount": "error";
                readonly "@eslint-react/no-component-will-receive-props": "error";
                readonly "@eslint-react/no-component-will-update": "error";
                readonly "@eslint-react/no-create-ref": "error";
                readonly "@eslint-react/no-direct-mutation-state": "error";
                readonly "@eslint-react/no-duplicate-key": "error";
                readonly "@eslint-react/no-missing-key": "error";
                readonly "@eslint-react/no-nested-components": "warn";
                readonly "@eslint-react/no-redundant-should-component-update": "error";
                readonly "@eslint-react/no-set-state-in-component-did-mount": "warn";
                readonly "@eslint-react/no-set-state-in-component-did-update": "warn";
                readonly "@eslint-react/no-set-state-in-component-will-update": "warn";
                readonly "@eslint-react/no-string-refs": "error";
                readonly "@eslint-react/no-unsafe-component-will-mount": "warn";
                readonly "@eslint-react/no-unsafe-component-will-receive-props": "warn";
                readonly "@eslint-react/no-unsafe-component-will-update": "warn";
                readonly "@eslint-react/no-unstable-context-value": "error";
                readonly "@eslint-react/no-unstable-default-props": "error";
                readonly "@eslint-react/no-unused-class-component-members": "warn";
                readonly "@eslint-react/no-unused-state": "warn";
                readonly "@eslint-react/no-useless-fragment": "warn";
                readonly "@eslint-react/prefer-destructuring-assignment": "warn";
                readonly "@eslint-react/prefer-shorthand-boolean": "warn";
                readonly "@eslint-react/prefer-shorthand-fragment": "warn";
                readonly "@eslint-react/dom/no-children-in-void-dom-elements": "warn";
                readonly "@eslint-react/dom/no-dangerously-set-innerhtml": "warn";
                readonly "@eslint-react/dom/no-dangerously-set-innerhtml-with-children": "error";
                readonly "@eslint-react/dom/no-find-dom-node": "error";
                readonly "@eslint-react/dom/no-missing-button-type": "warn";
                readonly "@eslint-react/dom/no-missing-iframe-sandbox": "warn";
                readonly "@eslint-react/dom/no-namespace": "error";
                readonly "@eslint-react/dom/no-render-return-value": "error";
                readonly "@eslint-react/dom/no-script-url": "warn";
                readonly "@eslint-react/dom/no-unsafe-iframe-sandbox": "warn";
                readonly "@eslint-react/dom/no-unsafe-target-blank": "warn";
            };
        };
    };
    readonly rules: {
        readonly "naming-convention/component-name": _typescript_eslint_utils_ts_eslint.RuleModule<"COMPONENT_NAME", readonly [{
            excepts?: readonly string[];
            rule?: "CONSTANT_CASE" | "PascalCase";
        } | "CONSTANT_CASE" | "PascalCase" | undefined], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "naming-convention/filename": _typescript_eslint_utils_ts_eslint.RuleModule<"FILENAME_CASE_MISMATCH" | "FILENAME_CASE_MISMATCH_SUGGESTION" | "FILENAME_EMPTY", readonly ["PascalCase" | {
            excepts?: readonly string[];
            extensions?: readonly string[];
            rule?: "PascalCase" | "camelCase" | "kebab-case" | "snake_case";
        } | "camelCase" | "kebab-case" | "snake_case" | undefined], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "naming-convention/filename-extension": _typescript_eslint_utils_ts_eslint.RuleModule<"FILE_NAME_EXTENSION_INVALID" | "FILE_NAME_EXTENSION_UNEXPECTED", readonly [{
            allow?: "always" | "as-needed";
            extensions?: readonly string[];
        } | "always" | "as-needed" | undefined], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "naming-convention/use-state": _typescript_eslint_utils_ts_eslint.RuleModule<"USE_STATE", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "hooks-extra/ensure-custom-hooks-using-other-hooks": _typescript_eslint_utils_ts_eslint.RuleModule<"ENSURE_CUSTOM_HOOKS_USING_OTHER_HOOKS", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "hooks-extra/ensure-use-callback-has-non-empty-deps": _typescript_eslint_utils_ts_eslint.RuleModule<"ENSURE_USE_CALLBACK_HAS_NON_EMPTY_DEPS", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "hooks-extra/ensure-use-memo-has-non-empty-deps": _typescript_eslint_utils_ts_eslint.RuleModule<"ENSURE_USE_MEMO_HAS_NON_EMPTY_DEPS", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "hooks-extra/prefer-use-state-lazy-initialization": _typescript_eslint_utils_ts_eslint.RuleModule<"PREFER_USE_STATE_LAZY_INITIALIZATION", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "dom/no-children-in-void-dom-elements": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_CHILDREN_IN_VOID_DOM_ELEMENTS", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "dom/no-dangerously-set-innerhtml": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_DANGEROUSLY_SET_INNERHTML", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "dom/no-dangerously-set-innerhtml-with-children": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_DANGEROUSLY_SET_INNERHTML_WITH_CHILDREN", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "dom/no-find-dom-node": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_FIND_DOM_NODE", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "dom/no-missing-button-type": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_MISSING_BUTTON_TYPE", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "dom/no-missing-iframe-sandbox": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_MISSING_IFRAME_SANDBOX", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "dom/no-namespace": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_NAMESPACE", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "dom/no-render-return-value": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_RENDER_RETURN_VALUE", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "dom/no-script-url": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_SCRIPT_URL", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "dom/no-unsafe-iframe-sandbox": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_UNSAFE_IFRAME_SANDBOX", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "dom/no-unsafe-target-blank": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_UNSAFE_TARGET_BLANK", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "avoid-shorthand-boolean": _typescript_eslint_utils_ts_eslint.RuleModule<"AVOID_SHORTHAND_BOOLEAN", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "avoid-shorthand-fragment": _typescript_eslint_utils_ts_eslint.RuleModule<"AVOID_SHORTHAND_FRAGMENT", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "ensure-forward-ref-using-ref": _typescript_eslint_utils_ts_eslint.RuleModule<"ENSURE_FORWARD_REF_USING_REF", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-access-state-in-setstate": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_ACCESS_STATE_IN_SETSTATE", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-array-index-key": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_ARRAY_INDEX_KEY", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-children-count": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_CHILDREN_COUNT", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-children-for-each": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_CHILDREN_FOR_EACH", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-children-map": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_CHILDREN_MAP", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-children-only": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_CHILDREN_ONLY", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-children-prop": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_CHILDREN_PROP", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-children-to-array": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_CHILDREN_TO_ARRAY", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-class-component": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_CLASS_COMPONENT", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-clone-element": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_CLONE_ELEMENT", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-comment-textnodes": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_COMMENT_TEXTNODES", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-complicated-conditional-rendering": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_COMPLICATED_CONDITIONAL_RENDERING", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-component-will-mount": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_COMPONENT_WILL_MOUNT", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-component-will-receive-props": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_COMPONENT_WILL_RECEIVE_PROPS", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-component-will-update": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_COMPONENT_WILL_UPDATE", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-create-ref": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_CREATE_REF", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-direct-mutation-state": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_DIRECT_MUTATION_STATE", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-duplicate-key": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_DUPLICATE_KEY", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-implicit-key": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_IMPLICIT_KEY", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-leaked-conditional-rendering": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_LEAKED_CONDITIONAL_RENDERING", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-missing-component-display-name": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_MISSING_COMPONENT_DISPLAY_NAME", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-missing-key": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_MISSING_KEY" | "NO_MISSING_KEY_WITH_FRAGMENT", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-nested-components": _typescript_eslint_utils_ts_eslint.RuleModule<"NESTED_COMPONENT" | "NESTED_COMPONENT_IN_PROPS", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-redundant-should-component-update": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_REDUNDANT_SHOULD_COMPONENT_UPDATE", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-set-state-in-component-did-mount": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_SET_STATE_IN_COMPONENT_DID_MOUNT", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-set-state-in-component-did-update": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_SET_STATE_IN_COMPONENT_DID_UPDATE", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-set-state-in-component-will-update": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_SET_STATE_IN_COMPONENT_WILL_UPDATE", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-string-refs": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_STRING_REFS", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-unsafe-component-will-mount": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_UNSAFE_COMPONENT_WILL_MOUNT", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-unsafe-component-will-receive-props": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_UNSAFE_COMPONENT_WILL_RECEIVE_PROPS", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-unsafe-component-will-update": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_UNSAFE_COMPONENT_WILL_UPDATE", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-unstable-context-value": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_UNSTABLE_CONTEXT_VALUE" | "NO_UNSTABLE_CONTEXT_VALUE_WITH_FUNCTION" | "NO_UNSTABLE_CONTEXT_VALUE_WITH_IDENTIFIER", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-unstable-default-props": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_UNSTABLE_DEFAULT_PROPS", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-unused-class-component-members": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_UNUSED_CLASS_COMPONENT_MEMBERS", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-unused-state": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_UNUSED_STATE", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "no-useless-fragment": _typescript_eslint_utils_ts_eslint.RuleModule<"NO_USELESS_FRAGMENT" | "NO_USELESS_FRAGMENT_IN_BUILT_IN", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "prefer-destructuring-assignment": _typescript_eslint_utils_ts_eslint.RuleModule<"PREFER_DESTRUCTURING_ASSIGNMENT", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "prefer-shorthand-boolean": _typescript_eslint_utils_ts_eslint.RuleModule<"PREFER_SHORTHAND_BOOLEAN", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
        readonly "prefer-shorthand-fragment": _typescript_eslint_utils_ts_eslint.RuleModule<"PREFER_SHORTHAND_FRAGMENT", [], _eslint_react_shared.ESLintPluginDocs, _typescript_eslint_utils_ts_eslint.RuleListener>;
    };
};

export { _default as default };
