'use strict';

var tsParser = require('@typescript-eslint/parser');
var reactCore = require('eslint-plugin-react-core');
var reactDom = require('eslint-plugin-react-dom');
var reactHooksExtra = require('eslint-plugin-react-hooks-extra');
var reactNamingConvention = require('eslint-plugin-react-naming-convention');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () { return e[k]; }
        });
      }
    });
  }
  n.default = e;
  return Object.freeze(n);
}

var tsParser__default = /*#__PURE__*/_interopDefault(tsParser);
var reactCore__namespace = /*#__PURE__*/_interopNamespace(reactCore);
var reactDom__namespace = /*#__PURE__*/_interopNamespace(reactDom);
var reactHooksExtra__namespace = /*#__PURE__*/_interopNamespace(reactHooksExtra);
var reactNamingConvention__namespace = /*#__PURE__*/_interopNamespace(reactNamingConvention);

var __defProp = Object.defineProperty;
var __export = (target, all2) => {
  for (var name2 in all2)
    __defProp(target, name2, { get: all2[name2], enumerable: true });
};

// ../../tools/dist/index.mjs
var fromEntries = (entries2) => {
  return Object.fromEntries(entries2);
};
var entries = (value) => {
  return Object.entries(value);
};

// package.json
var name = "@neetly-eslint-react/eslint-plugin";
var version = "1.5.15-beta.1";

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Function.js
var isFunction = (input) => typeof input === "function";
var dual = function(arity, body) {
  switch (arity) {
    case 0:
    case 1:
      throw new RangeError(`Invalid arity ${arity}`);
    case 2:
      return function(a, b) {
        if (arguments.length >= 2) {
          return body(a, b);
        }
        return function(self) {
          return body(self, a);
        };
      };
    case 3:
      return function(a, b, c) {
        if (arguments.length >= 3) {
          return body(a, b, c);
        }
        return function(self) {
          return body(self, a, b);
        };
      };
    case 4:
      return function(a, b, c, d) {
        if (arguments.length >= 4) {
          return body(a, b, c, d);
        }
        return function(self) {
          return body(self, a, b, c);
        };
      };
    case 5:
      return function(a, b, c, d, e) {
        if (arguments.length >= 5) {
          return body(a, b, c, d, e);
        }
        return function(self) {
          return body(self, a, b, c, d);
        };
      };
    default:
      return function() {
        if (arguments.length >= arity) {
          return body.apply(this, arguments);
        }
        const args = arguments;
        return function(self) {
          return body(self, ...args);
        };
      };
  }
};

// ../../../node_modules/.pnpm/effect@3.2.8/node_modules/effect/dist/esm/Predicate.js
var Predicate_exports = {};
__export(Predicate_exports, {
  all: () => all,
  and: () => and,
  compose: () => compose,
  eqv: () => eqv,
  every: () => every,
  hasProperty: () => hasProperty,
  implies: () => implies,
  isBigInt: () => isBigInt,
  isBoolean: () => isBoolean,
  isDate: () => isDate,
  isError: () => isError,
  isFunction: () => isFunction2,
  isIterable: () => isIterable,
  isMap: () => isMap,
  isNever: () => isNever,
  isNotNull: () => isNotNull,
  isNotNullable: () => isNotNullable,
  isNotUndefined: () => isNotUndefined,
  isNull: () => isNull,
  isNullable: () => isNullable,
  isNumber: () => isNumber,
  isObject: () => isObject,
  isPromise: () => isPromise,
  isPromiseLike: () => isPromiseLike,
  isReadonlyRecord: () => isReadonlyRecord,
  isRecord: () => isRecord,
  isSet: () => isSet,
  isString: () => isString,
  isSymbol: () => isSymbol,
  isTagged: () => isTagged,
  isTruthy: () => isTruthy,
  isUint8Array: () => isUint8Array,
  isUndefined: () => isUndefined,
  isUnknown: () => isUnknown,
  mapInput: () => mapInput,
  nand: () => nand,
  nor: () => nor,
  not: () => not,
  or: () => or,
  product: () => product,
  productMany: () => productMany,
  some: () => some,
  struct: () => struct,
  tuple: () => tuple,
  xor: () => xor
});
var mapInput = /* @__PURE__ */ dual(2, (self, f) => (b) => self(f(b)));
var isTruthy = (input) => !!input;
var isSet = (input) => input instanceof Set;
var isMap = (input) => input instanceof Map;
var isString = (input) => typeof input === "string";
var isNumber = (input) => typeof input === "number";
var isBoolean = (input) => typeof input === "boolean";
var isBigInt = (input) => typeof input === "bigint";
var isSymbol = (input) => typeof input === "symbol";
var isFunction2 = isFunction;
var isUndefined = (input) => input === void 0;
var isNotUndefined = (input) => input !== void 0;
var isNull = (input) => input === null;
var isNotNull = (input) => input !== null;
var isNever = (_) => false;
var isUnknown = (_) => true;
var isRecordOrArray = (input) => typeof input === "object" && input !== null;
var isObject = (input) => isRecordOrArray(input) || isFunction2(input);
var hasProperty = /* @__PURE__ */ dual(2, (self, property) => isObject(self) && property in self);
var isTagged = /* @__PURE__ */ dual(2, (self, tag) => hasProperty(self, "_tag") && self["_tag"] === tag);
var isNullable = (input) => input === null || input === void 0;
var isNotNullable = (input) => input !== null && input !== void 0;
var isError = (input) => input instanceof Error;
var isUint8Array = (input) => input instanceof Uint8Array;
var isDate = (input) => input instanceof Date;
var isIterable = (input) => hasProperty(input, Symbol.iterator);
var isRecord = (input) => isRecordOrArray(input) && !Array.isArray(input);
var isReadonlyRecord = isRecord;
var isPromise = (input) => hasProperty(input, "then") && "catch" in input && isFunction2(input.then) && isFunction2(input.catch);
var isPromiseLike = (input) => hasProperty(input, "then") && isFunction2(input.then);
var compose = /* @__PURE__ */ dual(2, (ab, bc) => (a) => ab(a) && bc(a));
var product = (self, that) => ([a, b]) => self(a) && that(b);
var all = (collection) => {
  return (as) => {
    let collectionIndex = 0;
    for (const p of collection) {
      if (collectionIndex >= as.length) {
        break;
      }
      if (p(as[collectionIndex]) === false) {
        return false;
      }
      collectionIndex++;
    }
    return true;
  };
};
var productMany = (self, collection) => {
  const rest = all(collection);
  return ([head, ...tail]) => self(head) === false ? false : rest(tail);
};
var tuple = (...elements) => all(elements);
var struct = (fields) => {
  const keys = Object.keys(fields);
  return (a) => {
    for (const key of keys) {
      if (!fields[key](a[key])) {
        return false;
      }
    }
    return true;
  };
};
var not = (self) => (a) => !self(a);
var or = /* @__PURE__ */ dual(2, (self, that) => (a) => self(a) || that(a));
var and = /* @__PURE__ */ dual(2, (self, that) => (a) => self(a) && that(a));
var xor = /* @__PURE__ */ dual(2, (self, that) => (a) => self(a) !== that(a));
var eqv = /* @__PURE__ */ dual(2, (self, that) => (a) => self(a) === that(a));
var implies = /* @__PURE__ */ dual(2, (self, that) => (a) => self(a) ? that(a) : true);
var nor = /* @__PURE__ */ dual(2, (self, that) => (a) => !(self(a) || that(a)));
var nand = /* @__PURE__ */ dual(2, (self, that) => (a) => !(self(a) && that(a)));
var every = (collection) => (a) => {
  for (const p of collection) {
    if (!p(a)) {
      return false;
    }
  }
  return true;
};
var some = (collection) => (a) => {
  for (const p of collection) {
    if (p(a)) {
      return true;
    }
  }
  return false;
};

// src/utils/transform-keys.ts
function transformKeys(obj, transform) {
  if (!Predicate_exports.isObject(obj)) return obj;
  const res = {};
  for (const key in obj) {
    res[transform(key)] = obj[key];
  }
  return res;
}

// src/utils/pad-keys.ts
function padKeysLeft(obj, left) {
  return transformKeys(obj, (key) => `${left}${key}`);
}

// src/index.ts
var allPreset = {
  "avoid-shorthand-boolean": "warn",
  "avoid-shorthand-fragment": "warn",
  "ensure-forward-ref-using-ref": "warn",
  "no-access-state-in-setstate": "error",
  "no-array-index-key": "warn",
  "no-children-count": "warn",
  "no-children-for-each": "warn",
  "no-children-map": "warn",
  "no-children-only": "warn",
  "no-children-prop": "warn",
  "no-children-to-array": "warn",
  "no-class-component": "warn",
  "no-clone-element": "warn",
  "no-comment-textnodes": "warn",
  // This rule has been deprecated
  // "no-complicated-conditional-rendering": "warn",
  "no-component-will-mount": "error",
  "no-component-will-receive-props": "error",
  "no-component-will-update": "error",
  "no-create-ref": "error",
  "no-direct-mutation-state": "error",
  "no-duplicate-key": "error",
  // This rule has been deprecated
  // "no-implicit-key": "error",
  // This rule requires type information
  // "no-leaked-conditional-rendering": "warn",
  "no-missing-component-display-name": "warn",
  "no-missing-key": "error",
  "no-nested-components": "warn",
  "no-redundant-should-component-update": "error",
  "no-set-state-in-component-did-mount": "warn",
  "no-set-state-in-component-did-update": "warn",
  "no-set-state-in-component-will-update": "warn",
  "no-string-refs": "error",
  "no-unsafe-component-will-mount": "warn",
  "no-unsafe-component-will-receive-props": "warn",
  "no-unsafe-component-will-update": "warn",
  "no-unstable-context-value": "error",
  "no-unstable-default-props": "error",
  "no-unused-class-component-members": "warn",
  "no-unused-state": "warn",
  "no-useless-fragment": "warn",
  "prefer-destructuring-assignment": "warn",
  "prefer-shorthand-boolean": "warn",
  "prefer-shorthand-fragment": "warn",
  // eslint-disable-next-line perfectionist/sort-objects
  "dom/no-children-in-void-dom-elements": "warn",
  "dom/no-dangerously-set-innerhtml": "warn",
  "dom/no-dangerously-set-innerhtml-with-children": "error",
  "dom/no-find-dom-node": "error",
  "dom/no-missing-button-type": "warn",
  "dom/no-missing-iframe-sandbox": "warn",
  "dom/no-namespace": "error",
  "dom/no-render-return-value": "error",
  "dom/no-script-url": "warn",
  "dom/no-unsafe-iframe-sandbox": "warn",
  "dom/no-unsafe-target-blank": "warn",
  "hooks-extra/ensure-custom-hooks-using-other-hooks": "warn",
  "hooks-extra/ensure-use-callback-has-non-empty-deps": "warn",
  "hooks-extra/ensure-use-memo-has-non-empty-deps": "warn",
  "hooks-extra/prefer-use-state-lazy-initialization": "warn",
  "naming-convention/component-name": "warn",
  "naming-convention/filename": "warn",
  "naming-convention/filename-extension": "warn",
  "naming-convention/use-state": "warn"
};
var recommendedPreset = {
  // "avoid-shorthand-boolean": "warn",
  // "avoid-shorthand-fragment": "warn",
  "ensure-forward-ref-using-ref": "warn",
  "no-access-state-in-setstate": "error",
  "no-array-index-key": "warn",
  "no-children-count": "warn",
  "no-children-for-each": "warn",
  "no-children-map": "warn",
  "no-children-only": "warn",
  "no-children-prop": "warn",
  "no-children-to-array": "warn",
  // "no-class-component": "warn",
  "no-clone-element": "warn",
  "no-comment-textnodes": "warn",
  // "no-complicated-conditional-rendering": "warn",
  "no-component-will-mount": "error",
  "no-component-will-receive-props": "error",
  "no-component-will-update": "error",
  "no-create-ref": "error",
  "no-direct-mutation-state": "error",
  "no-duplicate-key": "error",
  // "no-implicit-key": "error",
  // "no-leaked-conditional-rendering": "warn",
  // "no-missing-component-display-name": "warn",
  "no-missing-key": "error",
  "no-nested-components": "warn",
  "no-redundant-should-component-update": "error",
  "no-set-state-in-component-did-mount": "warn",
  "no-set-state-in-component-did-update": "warn",
  "no-set-state-in-component-will-update": "warn",
  "no-string-refs": "error",
  "no-unsafe-component-will-mount": "warn",
  "no-unsafe-component-will-receive-props": "warn",
  "no-unsafe-component-will-update": "warn",
  "no-unstable-context-value": "error",
  "no-unstable-default-props": "error",
  "no-unused-class-component-members": "warn",
  "no-unused-state": "warn",
  "no-useless-fragment": "warn",
  "prefer-destructuring-assignment": "warn",
  "prefer-shorthand-boolean": "warn",
  "prefer-shorthand-fragment": "warn",
  // eslint-disable-next-line perfectionist/sort-objects
  "dom/no-children-in-void-dom-elements": "warn",
  "dom/no-dangerously-set-innerhtml": "warn",
  "dom/no-dangerously-set-innerhtml-with-children": "error",
  "dom/no-find-dom-node": "error",
  "dom/no-missing-button-type": "warn",
  "dom/no-missing-iframe-sandbox": "warn",
  "dom/no-namespace": "error",
  "dom/no-render-return-value": "error",
  "dom/no-script-url": "warn",
  "dom/no-unsafe-iframe-sandbox": "warn",
  "dom/no-unsafe-target-blank": "warn"
};
var recommendedTypeCheckedPreset = {
  ...recommendedPreset,
  "no-leaked-conditional-rendering": "warn"
};
var domPreset = {
  "dom/no-children-in-void-dom-elements": "warn",
  "dom/no-dangerously-set-innerhtml": "warn",
  "dom/no-dangerously-set-innerhtml-with-children": "error",
  "dom/no-find-dom-node": "error",
  "dom/no-missing-button-type": "warn",
  "dom/no-missing-iframe-sandbox": "warn",
  "dom/no-namespace": "error",
  "dom/no-script-url": "warn",
  "dom/no-unsafe-iframe-sandbox": "warn",
  "dom/no-unsafe-target-blank": "warn"
};
var debugPreset = {
  "debug/class-component": "warn",
  "debug/function-component": "warn",
  "debug/react-hooks": "warn"
};
var allPresetEntries = entries(allPreset);
var offPreset = fromEntries(allPresetEntries.map(([key]) => [key, "off"]));
var offDomPreset = fromEntries(entries(domPreset).map(([key]) => [key, "off"]));
var legacyConfigPlugins = ["@eslint-react"];
var flatConfigPlugins = {
  "@eslint-react": reactCore__namespace,
  "@eslint-react/dom": reactDom__namespace,
  "@eslint-react/hooks-extra": reactHooksExtra__namespace,
  "@eslint-react/naming-convention": reactNamingConvention__namespace
};
function createLegacyConfig(rules5, plugins = legacyConfigPlugins) {
  return {
    parser: "@typescript-eslint/parser",
    plugins,
    rules: padKeysLeft(rules5, "@eslint-react/")
  };
}
function createFlatConfig(rules5, plugins = flatConfigPlugins) {
  return {
    languageOptions: {
      parser: tsParser__default.default
    },
    plugins,
    rules: padKeysLeft(rules5, "@eslint-react/")
  };
}
var src_default = {
  meta: {
    name,
    version
  },
  configs: {
    all: createFlatConfig(allPreset),
    debug: createFlatConfig(debugPreset),
    dom: createFlatConfig(domPreset),
    off: createFlatConfig(offPreset),
    "off-dom": createFlatConfig(offDomPreset),
    recommended: createFlatConfig(recommendedPreset),
    "recommended-type-checked": createFlatConfig(recommendedTypeCheckedPreset),
    // eslint-disable-next-line perfectionist/sort-objects
    "all-legacy": createLegacyConfig(allPreset),
    "debug-legacy": createLegacyConfig(debugPreset),
    "dom-legacy": createLegacyConfig(domPreset),
    "off-dom-legacy": createLegacyConfig(offDomPreset),
    "off-legacy": createLegacyConfig(offPreset),
    "recommended-legacy": createLegacyConfig(recommendedPreset),
    "recommended-type-checked-legacy": createLegacyConfig(recommendedTypeCheckedPreset)
  },
  rules: {
    ...reactCore__namespace.rules,
    ...padKeysLeft(reactDom__namespace.rules, "dom/"),
    ...padKeysLeft(reactHooksExtra__namespace.rules, "hooks-extra/"),
    ...padKeysLeft(reactNamingConvention__namespace.rules, "naming-convention/")
  }
};

module.exports = src_default;
